Bug 1205111

Summary: USB audio interface Edirol M-100FX is not recognized as audio interface anymore with kernel version > 6.0.2
Product: [openSUSE] openSUSE Tumbleweed Reporter: Wolfgang Engel <wolfgang.engel>
Component: KernelAssignee: openSUSE Kernel Bugs <kernel-bugs>
Status: RESOLVED FIXED QA Contact: E-mail List <qa-bugs>
Severity: Normal    
Priority: P5 - None CC: tiwai, wolfgang.engel
Version: Current   
Target Milestone: ---   
Hardware: x86-64   
OS: Other   
Whiteboard:
Found By: --- Services Priority:
Business Priority: Blocker: ---
Marketing QA Status: --- IT Deployment: ---
Attachments: dmesg kernel 6.0.2
dmesg kernel 6.0.6
lsusb on kernel 6.0.2
lsusb on kernel 6.0.6
lsusb -vv on kernel 6.0.2
lsusb -vv on kernel 6.0.6
alsa-info on kernel 6.0.2
alsa-info on kernel 6.0.6
dmesg with snd_usb_audio.dyndbg=+p option on kernel 6.0.6
Test fix patch
alsa-info on kernel 6.0.7-1.g590d345
dmesg with snd_usb_audio.dyndbg=+p option on kernel 6.0.7-1.g590d345
Revised test fix patch
Additional cleanup patch
Revised test fix patch (v2)
alsa-info on kernel 6.0.7-3.1.g413fea4
dmesg with snd_usb_audio.dyndbg=+p option on kernel 6.0.7-3.1.g413fea4
dmesg with snd_usb_audio.dyndbg=+p option on kernel 6.0.7-4.ge0a2b69
alsa-info on kernel 6.0.7-4.ge0a2b69
Revised fix patch (v3)

Description Wolfgang Engel 2022-11-06 21:56:25 UTC
Created attachment 862676 [details]
dmesg kernel 6.0.2

My USB audio interface is not recognized as audio interface anymore after upgrading to kernel version > 6.0.2

With kernel 6.0.2 the interface shows up correctly with aplay -l :

**** List of PLAYBACK Hardware Devices ****
card 0: M100FX [EDIROL M-100FX], device 0: USB Audio [USB Audio]
  Subdevices: 1/1
  Subdevice #0: subdevice #0
card 1: PCH [HDA Intel PCH], device 0: ALC3235 Analog [ALC3235 Analog]
  Subdevices: 1/1
  Subdevice #0: subdevice #0
card 1: PCH [HDA Intel PCH], device 3: HDMI 0 [HDMI 0]
  Subdevices: 1/1
  Subdevice #0: subdevice #0
card 1: PCH [HDA Intel PCH], device 7: HDMI 1 [HDMI 1]
  Subdevices: 1/1
  Subdevice #0: subdevice #0
card 1: PCH [HDA Intel PCH], device 8: HDMI 2 [HDMI 2]
  Subdevices: 1/1
  Subdevice #0: subdevice #0
card 1: PCH [HDA Intel PCH], device 9: HDMI 3 [HDMI 3]
  Subdevices: 1/1
  Subdevice #0: subdevice #0
card 1: PCH [HDA Intel PCH], device 10: HDMI 4 [HDMI 4]
  Subdevices: 1/1
  Subdevice #0: subdevice #0


With kernel 6.0.3 it doesn't show up anymore:

**** List of PLAYBACK Hardware Devices ****
card 1: PCH [HDA Intel PCH], device 0: ALC3235 Analog [ALC3235 Analog]
  Subdevices: 1/1
  Subdevice #0: subdevice #0
card 1: PCH [HDA Intel PCH], device 3: HDMI 0 [HDMI 0]
  Subdevices: 1/1
  Subdevice #0: subdevice #0
card 1: PCH [HDA Intel PCH], device 7: HDMI 1 [HDMI 1]
  Subdevices: 1/1
  Subdevice #0: subdevice #0
card 1: PCH [HDA Intel PCH], device 8: HDMI 2 [HDMI 2]
  Subdevices: 1/1
  Subdevice #0: subdevice #0
card 1: PCH [HDA Intel PCH], device 9: HDMI 3 [HDMI 3]
  Subdevices: 1/1
  Subdevice #0: subdevice #0
card 1: PCH [HDA Intel PCH], device 10: HDMI 4 [HDMI 4]
  Subdevices: 1/1
  Subdevice #0: subdevice #0

I attached the output from dmesg, lsusb and lsusb -vv from kernel version 6.0.2 and 6.0.6
Comment 1 Wolfgang Engel 2022-11-06 21:57:08 UTC
Created attachment 862677 [details]
dmesg kernel 6.0.6
Comment 2 Wolfgang Engel 2022-11-06 21:57:44 UTC
Created attachment 862678 [details]
lsusb on kernel 6.0.2
Comment 3 Wolfgang Engel 2022-11-06 21:58:03 UTC
Created attachment 862679 [details]
lsusb on kernel 6.0.6
Comment 4 Wolfgang Engel 2022-11-06 21:58:29 UTC
Created attachment 862680 [details]
lsusb -vv on kernel 6.0.2
Comment 5 Wolfgang Engel 2022-11-06 21:58:48 UTC
Created attachment 862681 [details]
lsusb -vv on kernel 6.0.6
Comment 6 Takashi Iwai 2022-11-07 07:01:00 UTC
Please give alsa-info.sh outputs from both working and non-working kernels.
Run the script with --no-upload option and attach the outputs to Bugzilla.
Comment 7 Takashi Iwai 2022-11-07 07:05:18 UTC
Also, please try to boot with snd_usb_audio.dyndbg=+p boot option on the new (broken) kernel and give the dmesg output.
Comment 8 Wolfgang Engel 2022-11-07 11:40:07 UTC
Created attachment 862691 [details]
alsa-info on kernel 6.0.2
Comment 9 Wolfgang Engel 2022-11-07 11:40:44 UTC
Created attachment 862692 [details]
alsa-info on kernel 6.0.6
Comment 10 Wolfgang Engel 2022-11-07 11:41:40 UTC
Created attachment 862693 [details]
dmesg with snd_usb_audio.dyndbg=+p option on kernel 6.0.6
Comment 11 Takashi Iwai 2022-11-07 12:08:39 UTC
Thanks.

This is likely a regression due to the recently introduced workaround for the delayed card registration of USB-audio driver.

I'm building a test kernel with the test fix patch in OBS home:tiwai:bsc1205111 repo.  Once after the build finishes (it takes for an hour or so), could you give it a try later?
Comment 12 Takashi Iwai 2022-11-07 12:09:00 UTC
Created attachment 862694 [details]
Test fix patch
Comment 13 Wolfgang Engel 2022-11-07 13:25:25 UTC
I installed your kernel 6.0.7-1.g590d345 but it has same behavior as kernel 6.0.6 . The audio interface doesn't show up.

I will attach the output of alsa-info.sh on kernel 6.0.7-1.g590d345 and dmesg with kernel option snd_usb_audio.dyndbg=+p on kernel 6.0.7-1.g590d345
Comment 14 Wolfgang Engel 2022-11-07 13:26:16 UTC
Created attachment 862695 [details]
alsa-info on kernel 6.0.7-1.g590d345
Comment 15 Wolfgang Engel 2022-11-07 13:26:41 UTC
Created attachment 862696 [details]
dmesg with snd_usb_audio.dyndbg=+p option on kernel 6.0.7-1.g590d345
Comment 16 Takashi Iwai 2022-11-07 14:00:32 UTC
Thanks.

I'm rebuilding the test kernel with the revised patches in the same OBS repo home:tiwai:bsc1205111.  The new kernel will have the release number *.g3169fa0.
Please give it a try later again.
Comment 17 Takashi Iwai 2022-11-07 14:01:10 UTC
Created attachment 862699 [details]
Revised test fix patch
Comment 18 Takashi Iwai 2022-11-07 14:01:31 UTC
Created attachment 862700 [details]
Additional cleanup patch
Comment 19 Takashi Iwai 2022-11-07 14:37:55 UTC
Oops, there was a typo in the previous patch.  Now refreshed and re-triggered.
The test kernel will have *.g413fea4 release instead.
Comment 20 Takashi Iwai 2022-11-07 14:38:29 UTC
Created attachment 862701 [details]
Revised test fix patch (v2)
Comment 21 Wolfgang Engel 2022-11-07 16:09:28 UTC
With kernel 6.0.7-3.1.g413fea4 the audio interface also don't show up.

I will attach the output of alsa-info and dmesg with kernel option
Comment 22 Wolfgang Engel 2022-11-07 16:09:55 UTC
Created attachment 862707 [details]
alsa-info on kernel 6.0.7-3.1.g413fea4
Comment 23 Wolfgang Engel 2022-11-07 16:10:39 UTC
Created attachment 862708 [details]
dmesg with snd_usb_audio.dyndbg=+p option on kernel 6.0.7-3.1.g413fea4
Comment 24 Takashi Iwai 2022-11-07 17:32:24 UTC
Hmm, it's deeper than I thought :-<

Now rebuilding again yet with a debug patch.  In the same OBS repo, a new kernel will have the release *.ge0a2b69.  This might work differently, but in anyway please give the dmesg with dyndbg again.
Comment 25 Wolfgang Engel 2022-11-07 20:25:44 UTC
Kernel 6.0.7-4.ge0a2b69 works!

Please find dmesg and alsa-info attached.
Comment 26 Wolfgang Engel 2022-11-07 20:26:17 UTC
Created attachment 862714 [details]
dmesg with snd_usb_audio.dyndbg=+p option on kernel 6.0.7-4.ge0a2b69
Comment 27 Wolfgang Engel 2022-11-07 20:26:43 UTC
Created attachment 862715 [details]
alsa-info on kernel 6.0.7-4.ge0a2b69
Comment 28 Takashi Iwai 2022-11-08 07:09:07 UTC
(In reply to Wolfgang Engel from comment #25)
> Kernel 6.0.7-4.ge0a2b69 works!

Good to hear!

The problem was two folds: the device declares the third interface as a MIDI interface, but the driver couldn't probe it because the descriptor is vendor-specific and incomplete.  Meanwhile, there was a bug in the driver that skips the card registration if the interface probe fails, and since the failed interface is the last one, the whole card registration is skipped.

I'm going to submit the fixes to the upstream and backport to TW and other kernels.

So the last question is: does this device have really a MIDI interface?  Through a quick glance at web pages, there seems no (physical) MIDI I/O.  If there is any, I can provide a patch to forcibly enable the interface, too.
Comment 29 Takashi Iwai 2022-11-08 07:09:59 UTC
Created attachment 862719 [details]
Revised fix patch (v3)
Comment 30 Wolfgang Engel 2022-11-08 07:37:59 UTC
Many thanks for fix and the explanation!

The audio interface doesn't have any physical MIDI connectors. So not sure where this declaration comes from.
Comment 31 Takashi Iwai 2022-11-08 07:47:38 UTC
OK, thanks, then it's fine as is.  The fixes are on the way for merge, let's close the bug.
Comment 43 Swamp Workflow Management 2022-12-16 17:32:00 UTC
SUSE-SU-2022:4504-1: An update that solves 22 vulnerabilities, contains 7 features and has 26 fixes is now available.

Category: security (important)
Bug References: 1065729,1156395,1164051,1184350,1189297,1190256,1193629,1194869,1202341,1203183,1204631,1204636,1204693,1204810,1204850,1205007,1205100,1205111,1205128,1205130,1205149,1205153,1205220,1205331,1205428,1205473,1205514,1205617,1205653,1205744,1205764,1205796,1205882,1205993,1206035,1206036,1206037,1206046,1206047,1206051,1206056,1206057,1206113,1206114,1206147,1206149,1206207,1206273
CVE References: CVE-2022-2602,CVE-2022-3176,CVE-2022-3566,CVE-2022-3567,CVE-2022-3635,CVE-2022-3643,CVE-2022-3707,CVE-2022-3903,CVE-2022-4095,CVE-2022-4129,CVE-2022-4139,CVE-2022-41850,CVE-2022-41858,CVE-2022-42328,CVE-2022-42329,CVE-2022-42895,CVE-2022-42896,CVE-2022-4378,CVE-2022-43945,CVE-2022-45869,CVE-2022-45888,CVE-2022-45934
JIRA References: PED-1573,PED-1706,PED-1936,PED-2684,PED-611,PED-824,PED-849
Sources used:
openSUSE Leap 15.4 (src):    kernel-azure-5.14.21-150400.14.28.1, kernel-source-azure-5.14.21-150400.14.28.1, kernel-syms-azure-5.14.21-150400.14.28.1
SUSE Linux Enterprise Module for Public Cloud 15-SP4 (src):    kernel-azure-5.14.21-150400.14.28.1, kernel-source-azure-5.14.21-150400.14.28.1, kernel-syms-azure-5.14.21-150400.14.28.1

NOTE: This line indicates an update has been released for the listed product(s). At times this might be only a partial fix. If you have questions please reach out to maintenance coordination.
Comment 47 Swamp Workflow Management 2022-12-20 17:41:04 UTC
SUSE-SU-2022:4585-1: An update that solves 22 vulnerabilities, contains 7 features and has 52 fixes is now available.

Category: security (important)
Bug References: 1065729,1156395,1164051,1184350,1189297,1190256,1193629,1194869,1202341,1203183,1203391,1203511,1203960,1204228,1204405,1204414,1204631,1204636,1204693,1204780,1204810,1204850,1205007,1205100,1205111,1205113,1205128,1205130,1205149,1205153,1205220,1205264,1205282,1205331,1205332,1205427,1205428,1205473,1205507,1205514,1205521,1205567,1205616,1205617,1205653,1205671,1205679,1205683,1205700,1205705,1205709,1205711,1205744,1205764,1205796,1205882,1205993,1206035,1206036,1206037,1206045,1206046,1206047,1206048,1206049,1206050,1206051,1206056,1206057,1206113,1206114,1206147,1206149,1206207
CVE References: CVE-2022-2602,CVE-2022-3176,CVE-2022-3566,CVE-2022-3567,CVE-2022-3635,CVE-2022-3643,CVE-2022-3707,CVE-2022-3903,CVE-2022-4095,CVE-2022-4129,CVE-2022-4139,CVE-2022-41850,CVE-2022-41858,CVE-2022-42328,CVE-2022-42329,CVE-2022-42895,CVE-2022-42896,CVE-2022-4378,CVE-2022-43945,CVE-2022-45869,CVE-2022-45888,CVE-2022-45934
JIRA References: PED-1573,PED-1706,PED-1936,PED-2684,PED-611,PED-824,PED-849
Sources used:
openSUSE Leap Micro 5.3 (src):    kernel-default-5.14.21-150400.24.38.1, kernel-default-base-5.14.21-150400.24.38.1.150400.24.13.2
openSUSE Leap 15.4 (src):    dtb-aarch64-5.14.21-150400.24.38.1, kernel-64kb-5.14.21-150400.24.38.1, kernel-debug-5.14.21-150400.24.38.1, kernel-default-5.14.21-150400.24.38.1, kernel-default-base-5.14.21-150400.24.38.1.150400.24.13.2, kernel-docs-5.14.21-150400.24.38.1, kernel-kvmsmall-5.14.21-150400.24.38.1, kernel-obs-build-5.14.21-150400.24.38.1, kernel-obs-qa-5.14.21-150400.24.38.1, kernel-source-5.14.21-150400.24.38.1, kernel-syms-5.14.21-150400.24.38.1, kernel-zfcpdump-5.14.21-150400.24.38.1
SUSE Linux Enterprise Workstation Extension 15-SP4 (src):    kernel-default-5.14.21-150400.24.38.1
SUSE Linux Enterprise Module for Live Patching 15-SP4 (src):    kernel-default-5.14.21-150400.24.38.1, kernel-livepatch-SLE15-SP4_Update_6-1-150400.9.3.2
SUSE Linux Enterprise Module for Legacy Software 15-SP4 (src):    kernel-default-5.14.21-150400.24.38.1
SUSE Linux Enterprise Module for Development Tools 15-SP4 (src):    kernel-docs-5.14.21-150400.24.38.1, kernel-obs-build-5.14.21-150400.24.38.1, kernel-source-5.14.21-150400.24.38.1, kernel-syms-5.14.21-150400.24.38.1
SUSE Linux Enterprise Module for Basesystem 15-SP4 (src):    kernel-64kb-5.14.21-150400.24.38.1, kernel-default-5.14.21-150400.24.38.1, kernel-default-base-5.14.21-150400.24.38.1.150400.24.13.2, kernel-source-5.14.21-150400.24.38.1, kernel-zfcpdump-5.14.21-150400.24.38.1
SUSE Linux Enterprise Micro 5.3 (src):    kernel-default-5.14.21-150400.24.38.1, kernel-default-base-5.14.21-150400.24.38.1.150400.24.13.2
SUSE Linux Enterprise High Availability 15-SP4 (src):    kernel-default-5.14.21-150400.24.38.1

NOTE: This line indicates an update has been released for the listed product(s). At times this might be only a partial fix. If you have questions please reach out to maintenance coordination.
Comment 48 Swamp Workflow Management 2022-12-23 15:25:58 UTC
SUSE-SU-2022:4617-1: An update that solves 96 vulnerabilities, contains 50 features and has 246 fixes is now available.

Category: security (important)
Bug References: 1023051,1032323,1065729,1071995,1152472,1152489,1156395,1164051,1177471,1184350,1185032,1188238,1189297,1189999,1190256,1190497,1190969,1192968,1193629,1194023,1194592,1194869,1194904,1195480,1195917,1196018,1196444,1196616,1196632,1196867,1196869,1197158,1197391,1197659,1197755,1197756,1197757,1197763,1198189,1198410,1198577,1198702,1198971,1199086,1199364,1199515,1199670,1199904,1200015,1200058,1200268,1200288,1200301,1200313,1200431,1200465,1200494,1200544,1200567,1200622,1200644,1200651,1200692,1200788,1200845,1200868,1200869,1200870,1200871,1200872,1200873,1201019,1201308,1201309,1201310,1201361,1201427,1201442,1201455,1201489,1201610,1201675,1201725,1201726,1201768,1201865,1201940,1201941,1201948,1201954,1201956,1201958,1202095,1202096,1202097,1202113,1202131,1202154,1202187,1202262,1202265,1202312,1202341,1202346,1202347,1202385,1202393,1202447,1202471,1202558,1202623,1202636,1202672,1202681,1202685,1202686,1202700,1202710,1202711,1202712,1202713,1202715,1202716,1202757,1202758,1202759,1202761,1202762,1202763,1202764,1202765,1202766,1202767,1202768,1202769,1202770,1202771,1202773,1202774,1202775,1202776,1202778,1202779,1202780,1202781,1202782,1202783,1202822,1202823,1202824,1202860,1202867,1202872,1202874,1202898,1202914,1202960,1202989,1202992,1202993,1203002,1203008,1203036,1203039,1203041,1203063,1203066,1203067,1203098,1203101,1203107,1203116,1203117,1203138,1203139,1203159,1203183,1203197,1203208,1203229,1203263,1203290,1203338,1203360,1203361,1203389,1203391,1203410,1203435,1203505,1203511,1203514,1203552,1203606,1203664,1203693,1203699,1203767,1203769,1203770,1203794,1203798,1203802,1203829,1203893,1203902,1203906,1203908,1203922,1203935,1203939,1203960,1203969,1203987,1203992,1203994,1204017,1204051,1204059,1204060,1204092,1204125,1204132,1204142,1204166,1204168,1204170,1204171,1204183,1204228,1204241,1204289,1204290,1204291,1204292,1204353,1204354,1204355,1204402,1204405,1204413,1204414,1204415,1204417,1204424,1204428,1204431,1204432,1204439,1204470,1204479,1204486,1204498,1204533,1204569,1204574,1204575,1204576,1204619,1204624,1204631,1204635,1204636,1204637,1204646,1204647,1204650,1204653,1204693,1204705,1204719,1204728,1204745,1204753,1204780,1204810,1204850,1204868,1204926,1204933,1204934,1204947,1204957,1204963,1204970,1205007,1205100,1205111,1205113,1205128,1205130,1205149,1205153,1205220,1205257,1205264,1205282,1205313,1205331,1205332,1205427,1205428,1205473,1205496,1205507,1205514,1205521,1205567,1205616,1205617,1205653,1205671,1205679,1205683,1205700,1205705,1205709,1205711,1205744,1205764,1205796,1205882,1205993,1206035,1206036,1206037,1206045,1206046,1206047,1206048,1206049,1206050,1206051,1206056,1206057,1206113,1206114,1206147,1206149,1206207,1206273,1206391
CVE References: CVE-2016-3695,CVE-2020-16119,CVE-2020-36516,CVE-2021-33135,CVE-2021-4037,CVE-2022-1184,CVE-2022-1263,CVE-2022-1882,CVE-2022-20368,CVE-2022-20369,CVE-2022-2153,CVE-2022-2586,CVE-2022-2588,CVE-2022-2602,CVE-2022-26373,CVE-2022-2639,CVE-2022-2663,CVE-2022-28356,CVE-2022-28693,CVE-2022-2873,CVE-2022-28748,CVE-2022-2905,CVE-2022-2938,CVE-2022-2959,CVE-2022-2964,CVE-2022-2977,CVE-2022-2978,CVE-2022-3028,CVE-2022-3078,CVE-2022-3114,CVE-2022-3169,CVE-2022-3176,CVE-2022-3202,CVE-2022-32250,CVE-2022-32296,CVE-2022-3239,CVE-2022-3303,CVE-2022-33981,CVE-2022-3424,CVE-2022-3435,CVE-2022-3521,CVE-2022-3524,CVE-2022-3526,CVE-2022-3535,CVE-2022-3542,CVE-2022-3545,CVE-2022-3565,CVE-2022-3566,CVE-2022-3567,CVE-2022-3577,CVE-2022-3586,CVE-2022-3594,CVE-2022-3619,CVE-2022-3621,CVE-2022-3625,CVE-2022-3628,CVE-2022-3629,CVE-2022-3633,CVE-2022-3635,CVE-2022-3640,CVE-2022-3643,CVE-2022-3646,CVE-2022-3649,CVE-2022-36879,CVE-2022-36946,CVE-2022-3707,CVE-2022-3903,CVE-2022-39188,CVE-2022-39189,CVE-2022-39190,CVE-2022-40476,CVE-2022-40768,CVE-2022-4095,CVE-2022-41218,CVE-2022-4129,CVE-2022-4139,CVE-2022-41674,CVE-2022-41848,CVE-2022-41849,CVE-2022-41850,CVE-2022-41858,CVE-2022-42328,CVE-2022-42329,CVE-2022-42703,CVE-2022-42719,CVE-2022-42720,CVE-2022-42721,CVE-2022-42722,CVE-2022-42895,CVE-2022-42896,CVE-2022-43750,CVE-2022-4378,CVE-2022-43945,CVE-2022-45869,CVE-2022-45888,CVE-2022-45934
JIRA References: PED-1082,PED-1084,PED-1085,PED-1096,PED-1211,PED-1573,PED-1649,PED-1706,PED-1936,PED-2684,PED-387,PED-529,PED-611,PED-634,PED-652,PED-664,PED-676,PED-678,PED-679,PED-682,PED-688,PED-707,PED-720,PED-729,PED-732,PED-755,PED-763,PED-813,PED-817,PED-822,PED-824,PED-825,PED-833,PED-842,PED-846,PED-849,PED-850,PED-851,PED-856,PED-857,SLE-13847,SLE-18130,SLE-19359,SLE-19924,SLE-20183,SLE-23766,SLE-24572,SLE-24682,SLE-24814,SLE-9246
Sources used:
openSUSE Leap Micro 5.3 (src):    kernel-rt-5.14.21-150400.15.5.1
openSUSE Leap 15.4 (src):    kernel-rt-5.14.21-150400.15.5.1, kernel-rt_debug-5.14.21-150400.15.5.1, kernel-source-rt-5.14.21-150400.15.5.1, kernel-syms-rt-5.14.21-150400.15.5.1
SUSE Linux Enterprise Module for Realtime 15-SP4 (src):    kernel-rt-5.14.21-150400.15.5.1, kernel-rt_debug-5.14.21-150400.15.5.1, kernel-source-rt-5.14.21-150400.15.5.1, kernel-syms-rt-5.14.21-150400.15.5.1
SUSE Linux Enterprise Module for Live Patching 15-SP4 (src):    kernel-livepatch-SLE15-SP4-RT_Update_1-1-150400.1.3.1
SUSE Linux Enterprise Micro 5.3 (src):    kernel-rt-5.14.21-150400.15.5.1

NOTE: This line indicates an update has been released for the listed product(s). At times this might be only a partial fix. If you have questions please reach out to maintenance coordination.